package org.apache.hadoop.hbase.generated.master;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import java.util.*;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.hbase.HMaster;
import org.apache.hadoop.hbase.HConstants;
import org.apache.hadoop.hbase.HMaster.MetaRegion;
import org.apache.hadoop.hbase.HBaseAdmin;
import org.apache.hadoop.hbase.HServerInfo;
import org.apache.hadoop.hbase.HServerAddress;
import org.apache.hadoop.hbase.HRegionInfo;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.shell.ShowCommand;
import org.apache.hadoop.hbase.shell.TableFormatter;
import org.apache.hadoop.hbase.shell.ReturnMsg;
import org.apache.hadoop.hbase.shell.formatter.HtmlTableFormatter;
import org.apache.hadoop.hbase.HTableDescriptor;

public final class master_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {

  private static java.util.Vector _jspx_dependants;

  public java.util.List getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html;charset=UTF-8");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;


  HMaster master = (HMaster)getServletContext().getAttribute(HMaster.MASTER);
  HBaseConfiguration conf = new HBaseConfiguration();
  TableFormatter formatter = new HtmlTableFormatter(out);
  ShowCommand show = new ShowCommand(out, formatter, "tables");
  HServerAddress rootLocation = master.getRootRegionLocation();
  Map<Text, MetaRegion> onlineRegions = master.getOnlineMetaRegions();
  Map<String, HServerInfo> serverToServerInfos =
    master.getServersToServerInfo();

      out.write("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\r\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \r\n  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\"> \r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n<head><meta http-equiv=\"Content-Type\" content=\"text/html;charset=UTF-8\"/>\r\n<title>Hbase Master: ");
      out.print( master.getMasterAddress());
      out.write("</title>\r\n<link rel=\"stylesheet\" type=\"text/css\" href=\"/static/hbase.css\" />\r\n</head>\r\n\r\n<body>\r\n\r\n<a id=\"logo\" href=\"http://wiki.apache.org/lucene-hadoop/Hbase\"><img src=\"/static/hbase_logo_med.gif\" alt=\"Hbase Logo\" title=\"Hbase Logo\" /></a>\r\n<h1 id=\"page_title\">Master: ");
      out.print(master.getMasterAddress());
      out.write("</h1>\r\n<p id=\"links_menu\"><a href=\"/hql.jsp\">HQL</a>, <a href=\"/logs/\">Local logs</a>, <a href=\"/stacks\">Thread Dump</a></p>\r\n<hr id=\"head_rule\" />\r\n\r\n<h2>Master Attributes</h2>\r\n<table>\r\n<tr><th>Attribute Name</th><th>Value</th></tr>\r\n<tr><td>Filesystem</td><td>");
      out.print( conf.get("fs.default.name") );
      out.write("</td></tr>\r\n<tr><td>Hbase Root Directory</td><td>");
      out.print( master.getRootDir().toString() );
      out.write("</td></tr>\r\n</table>\r\n\r\n<h2>Online META Regions</h2>\r\n");
 if (rootLocation != null) { 
      out.write("\r\n<table>\r\n<tr><th>Name</th><th>Server</th></tr>\r\n<tr><td>");
      out.print( HConstants.ROOT_TABLE_NAME.toString() );
      out.write("</td><td>");
      out.print( rootLocation.toString() );
      out.write("</td></tr>\r\n");

  if (onlineRegions != null && onlineRegions.size() > 0) { 
      out.write("\r\n  ");
 for (Map.Entry<Text, HMaster.MetaRegion> e: onlineRegions.entrySet()) {
    MetaRegion meta = e.getValue();
  
      out.write("\r\n  <tr><td>");
      out.print( meta.getRegionName().toString() );
      out.write("</td><td>");
      out.print( meta.getServer().toString() );
      out.write("</td></tr>\r\n  ");
 }
  } 
      out.write("\r\n</table>\r\n");
 } 
      out.write("\r\n\r\n<h2>Tables</h2>\r\n");
 ReturnMsg msg = show.execute(conf); 
      out.write("\r\n<p>");
      out.print(msg );
      out.write("</p>\r\n\r\n<h2>Region Servers</h2>\r\n");
 if (serverToServerInfos != null && serverToServerInfos.size() > 0) { 
      out.write("\r\n<table>\r\n<tr><th>Address</th><th>Start Code</th><th>Load</th></tr>\r\n");
   for (Map.Entry<String, HServerInfo> e: serverToServerInfos.entrySet()) {
       HServerInfo hsi = e.getValue();
       String url = "http://" +
         hsi.getServerAddress().getBindAddress().toString() + ":" +
         hsi.getInfoPort() + "/";
       String load = hsi.getLoad().toString();
       long startCode = hsi.getStartCode();
       String address = hsi.getServerAddress().toString();

      out.write("\r\n<tr><td><a href=\"");
      out.print( url );
      out.write('"');
      out.write('>');
      out.print( address );
      out.write("</a></td><td>");
      out.print( startCode );
      out.write("</td><td>");
      out.print( load );
      out.write("</tr>\r\n");
   } 
      out.write("\r\n</table>\r\n");
 } 
      out.write("\r\n</body>\r\n</html>\r\n");
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
